>From 2362772aa3142f45b1c2f948a17dc8e719a1879d Mon Sep 17 00:00:00 2001
From: Jan Lieskovsky <jlieskov@redhat.com>
Date: Thu, 22 May 2014 17:08:31 +0200
Subject: [PATCH 2/3] [RHEL/6] Fix "Invalid OVAL definition referenced by XCCDF
 Rule: root_path_no_dot" ../utils/verify-references.py warning message

Signed-off-by: Jan Lieskovsky <jlieskov@redhat.com>
---
 RHEL/6/input/checks/root_path_no_dot.xml | 18 +++++++++---------
 1 file changed, 9 insertions(+), 9 deletions(-)

diff --git a/RHEL/6/input/checks/root_path_no_dot.xml b/RHEL/6/input/checks/root_path_no_dot.xml
index 0d528b5..8f33914 100644
--- a/RHEL/6/input/checks/root_path_no_dot.xml
+++ b/RHEL/6/input/checks/root_path_no_dot.xml
@@ -1,5 +1,5 @@
 <def-group>
-  <definition class="compliance" id="root_path_no_dot.xml" version="1">
+  <definition class="compliance" id="root_path_no_dot" version="2">
     <metadata>
       <title>Ensure that No Dangerous Directories Exist in Root's Path</title>
       <affected family="unix">
@@ -7,7 +7,7 @@
       </affected>
       <description>The environment variable PATH should be set correctly for
       the root user.</description>
-      <reference source="MED" ref_id="20130925" ref_url="test_attestation" />
+      <reference source="JL" ref_id="20140522" ref_url="test_attestation" />
     </metadata>
     <criteria comment="environment variable PATH contains dangerous path" operator="AND">
       <criterion comment="environment variable PATH starts with : or ." test_ref="test_env_var_begins" />
@@ -18,7 +18,7 @@
       <criterion comment="environment variable PATH doesn't contain relative paths" test_ref="test_env_var_contains_relative_path" />
     </criteria>
   </definition>
-  <ind:environmentvariable58_object id="object_root_path_no_dot.xml"
+  <ind:environmentvariable58_object id="object_root_path_no_dot"
   version="1">
     <ind:pid xsi:nil="true" datatype="int" />
     <ind:name>PATH</ind:name>
@@ -26,37 +26,37 @@
   <ind:environmentvariable58_test check="none satisfy"
   comment="environment variable PATH starts with : or ."
   id="test_env_var_begins" version="1">
-    <ind:object object_ref="object_root_path_no_dot.xml" />
+    <ind:object object_ref="object_root_path_no_dot" />
     <ind:state state_ref="state_begins_colon_period" />
   </ind:environmentvariable58_test>
   <ind:environmentvariable58_test check="none satisfy"
   comment="environment variable PATH doesn't contain : twice in a row"
   id="test_env_var_contains_doublecolon" version="1">
-    <ind:object object_ref="object_root_path_no_dot.xml" />
+    <ind:object object_ref="object_root_path_no_dot" />
     <ind:state state_ref="state_contains_double_colon" />
   </ind:environmentvariable58_test>
   <ind:environmentvariable58_test check="none satisfy"
   comment="environment variable PATH doesn't contain . twice in a row"
   id="test_env_var_contains_doubleperiod" version="1">
-    <ind:object object_ref="object_root_path_no_dot.xml" />
+    <ind:object object_ref="object_root_path_no_dot" />
     <ind:state state_ref="state_contains_double_period" />
   </ind:environmentvariable58_test>
   <ind:environmentvariable58_test check="none satisfy"
   comment="environment variable PATH ends with : or ." id="test_env_var_ends"
   version="1">
-    <ind:object object_ref="object_root_path_no_dot.xml" />
+    <ind:object object_ref="object_root_path_no_dot" />
     <ind:state state_ref="state_ends_colon_period" />
   </ind:environmentvariable58_test>
   <ind:environmentvariable58_test check="none satisfy"
   comment="environment variable PATH starts with an absolute path /"
   id="test_env_var_begins_slash" version="1">
-    <ind:object object_ref="object_root_path_no_dot.xml" />
+    <ind:object object_ref="object_root_path_no_dot" />
     <ind:state state_ref="state_begins_slash" />
   </ind:environmentvariable58_test>
   <ind:environmentvariable58_test check="none satisfy"
   comment="environment variable PATH contains relative paths"
   id="test_env_var_contains_relative_path" version="1">
-    <ind:object object_ref="object_root_path_no_dot.xml" />
+    <ind:object object_ref="object_root_path_no_dot" />
     <ind:state state_ref="state_contains_relative_path" />
   </ind:environmentvariable58_test>
   <ind:environmentvariable58_state comment="starts with colon or period"
-- 
1.8.3.1