From 0865ed772dc81308bc223da238d212a0b94cdd88 Mon Sep 17 00:00:00 2001
From: Yuri Chornoivan <yurchor@ukr.net>
Date: Tue, 20 Jul 2010 08:13:15 -0400
Subject: [PATCH 3/3] Updating uk translation

---
 src/po/uk.po |   44 +++++++++++++++++++++++---------------------
 1 files changed, 23 insertions(+), 21 deletions(-)

diff --git a/src/po/uk.po b/src/po/uk.po
index 38b13394e8fe608517cc068214c05b1b88f76abd..6401fc77b104299be1f8b6d704af0ac56ec0329f 100644
--- a/src/po/uk.po
+++ b/src/po/uk.po
@@ -7,16 +7,16 @@ msgstr ""
 "Project-Id-Version: \n"
 "Report-Msgid-Bugs-To: sssd-devel@lists.fedorahosted.org\n"
 "POT-Creation-Date: 2010-07-09 13:48-0400\n"
-"PO-Revision-Date: 2010-04-12 19:12+0300\n"
+"PO-Revision-Date: 2010-07-18 10:13+0300\n"
 "Last-Translator: Yuri Chornoivan <yurchor@ukr.net>\n"
 "Language-Team: Ukrainian <translation@linux.org.ua>\n"
-"Language: uk\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Generator: Lokalize 1.0\n"
-"Plural-Forms: nplurals=3; plural=(n%10==1 && n%100!=11 ? 0 : n%10>=2 && n"
-"%10<=4 && (n%100<10 || n%100>=20) ? 1 : 2);\n"
+"Language: uk\n"
+"X-Generator: Lokalize 1.1\n"
+"Plural-Forms: nplurals=3; plural=(n%10==1 && n%100!=11 ? 0 : n%10>=2 && "
+"n%10<=4 && (n%100<10 || n%100>=20) ? 1 : 2);\n"
 
 #: config/SSSDConfig.py:39
 msgid "Set the verbosity of the debug logging"
@@ -172,10 +172,12 @@ msgstr ""
 #: config/SSSDConfig.py:84
 msgid "How long to wait for replies from DNS when resolving servers (seconds)"
 msgstr ""
+"Тривалість очікування на відповідь від DNS під час визначення адрес серверів "
+"(у секундах)"
 
 #: config/SSSDConfig.py:85
 msgid "The domain part of service discovery DNS query"
-msgstr ""
+msgstr "Частина запиту щодо виявлення служби DNS, пов’язана з доменом"
 
 #: config/SSSDConfig.py:88
 msgid "IPA domain"
@@ -192,10 +194,13 @@ msgstr "Назва вузла клієнта IPA"
 #: config/SSSDConfig.py:91
 msgid "Whether to automatically update the client's DNS entry in FreeIPA"
 msgstr ""
+"Визначає, чи слід автоматично оновлювати запис DNS клієнтського вузла у "
+"FreeIPA"
 
 #: config/SSSDConfig.py:92
 msgid "The interface whose IP should be used for dynamic DNS updates"
 msgstr ""
+"Інтерфейс, чию адресу IP має бути використано для динамічних оновлень DNS"
 
 #: config/SSSDConfig.py:95 config/SSSDConfig.py:124
 msgid "Kerberos server address"
@@ -227,7 +232,7 @@ msgstr "Увімкнути перевірку реєстраційних дан
 
 #: config/SSSDConfig.py:104
 msgid "Store password if offline for later online authentication"
-msgstr ""
+msgstr "Зберігати пароль у автономному режимі для розпізнавання у мережі"
 
 #: config/SSSDConfig.py:107
 msgid "Server where the change password service is running if not on the KDC"
@@ -306,9 +311,8 @@ msgid "Follow LDAP referrals"
 msgstr "Переходити за посиланнями LDAP"
 
 #: config/SSSDConfig.py:129
-#, fuzzy
 msgid "Lifetime of TGT for LDAP connection"
-msgstr "Розпізнавання Kerberos для з’єднання LDAP"
+msgstr "Строк дії TGT для з’єднання LDAP"
 
 #: config/SSSDConfig.py:132
 msgid "Length of time to wait for a search request"
@@ -388,7 +392,7 @@ msgstr "Правила оцінки завершення строку дії п
 
 #: config/SSSDConfig.py:155
 msgid "LDAP filter to determine access privileges"
-msgstr ""
+msgstr "Фільтр LDAP для визначення прав доступу"
 
 #: config/SSSDConfig.py:158
 msgid "Comma separated list of allowed users"
@@ -472,28 +476,27 @@ msgstr "Домен надання відомостей (обов’язкови
 
 #: sss_client/common.c:743
 msgid "Privileged socket has wrong ownership or permissions."
-msgstr ""
+msgstr "У привілейованого сокета помилковий власник або права доступу."
 
 #: sss_client/common.c:746
 msgid "Public socket has wrong ownership or permissions."
-msgstr ""
+msgstr "У відкритого сокета помилковий власник або права доступу."
 
 #: sss_client/common.c:749
-#, fuzzy
 msgid "Unexpected format of the server credential message."
-msgstr "Адреса кешу реєстраційних даних користувача"
+msgstr "Некоректний формат повідомлення щодо реєстраційних даних сервера."
 
 #: sss_client/common.c:752
 msgid "SSSD is not run by root."
-msgstr ""
+msgstr "SSSD запущено не від імені користувача root."
 
 #: sss_client/common.c:757
 msgid "An error occurred, but no description can be found."
-msgstr ""
+msgstr "Сталася помилка, але не вдалося знайти її опису."
 
 #: sss_client/common.c:763
 msgid "Unexpected error while looking for an error description"
-msgstr ""
+msgstr "Неочікувана помилка під час пошуку опису помилки"
 
 #: sss_client/pam_sss.c:372
 msgid "Passwords do not match"
@@ -501,11 +504,11 @@ msgstr "Паролі не збігаються"
 
 #: sss_client/pam_sss.c:556
 msgid "Password reset by root is not supported."
-msgstr ""
+msgstr "Підтримки скидання пароля користувачем root не передбачено."
 
 #: sss_client/pam_sss.c:597
 msgid "Authenticated with cached credentials"
-msgstr ""
+msgstr "Розпізнано за реєстраційними даними з кешу"
 
 #: sss_client/pam_sss.c:598
 msgid ", your cached password will expire at: "
@@ -522,9 +525,8 @@ msgid "Your password will expire in %d %s."
 msgstr "Строк дії вашого пароля завершиться за %d %s."
 
 #: sss_client/pam_sss.c:723
-#, fuzzy
 msgid "Authentication is denied until: "
-msgstr "Автономне розпізнавання, розпізнавання заборонено до: "
+msgstr "Розпізнавання заборонено до: "
 
 #: sss_client/pam_sss.c:750
 msgid "System is offline, password change not possible"
-- 
1.7.1.1